#ifndef EO_CLASS_EO_HH
#define EO_CLASS_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_class.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace eo { 
struct Class;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eo::Class> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eo { 
struct Class {
   static Eo_Class const* _eo_class()
   {
      return EO_CLASS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eo::Class() const;
   operator ::eo::Class&();
   operator ::eo::Class const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Class> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Class const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace eo { 
struct Class : ::efl::eo::concrete
{
   explicit Class( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Class(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Class(Class const& other) = default;
   Class(Class&& other) = default;
   Class& operator=(Class const& other) = default;
   Class& operator=(Class&& other) = default;
   Class()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Class( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Class(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EO_CLASS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Class> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Class const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Class) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Class>::value, "");
} 
#include "eo_class.eo.impl.hh"
#endif
